#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gr_io_signature.h>
#include <ccr_receiver_cf.h>
#include <stdio.h>
#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/thread/thread.hpp> 

ccr_receiver_cf_sptr
ccr_make_receiver_cf()
{
    return ccr_receiver_cf_sptr(new ccr_receiver_cf());
}


int MIN_IN = 1;
int MAX_IN = 125;
int MIN_OUT = 1;
int MAX_OUT = 1;

/*
 * The private constructor
 */
ccr_receiver_cf::ccr_receiver_cf()
    : gr_block("ccr_receiver",
               gr_make_io_signature(MIN_IN, MAX_IN, sizeof(gr_complex)),
               gr_make_io_signature(MIN_OUT, MAX_OUT, sizeof(float)))
{

}

/*
 * Virtual destructor.
 */
ccr_receiver_cf::~ccr_receiver_cf()
{
}

void ccr_receiver_cf::forecast(int noutput_items, gr_vector_int &nitems_items_required)
{
  for(int i = 0; i < nitems_items_required.size(); i++)
    nitems_items_required[i] = noutput_items;
}

static int st = 0;

int
ccr_receiver_cf::general_work(int noutput_items,
                              gr_vector_int &nitems_items,
                              gr_vector_const_void_star &input_items,
                              gr_vector_void_star &output_items)
{
  //boost::this_thread::sleep(boost::posix_time::microseconds(500));

  st++;
 
  for(int j = 0; j < 6; j++)
  {
    for(int i = 0; i < nitems_items[j]*sizeof(gr_complex); i++)
    {
        if (*((char *)input_items[j]+i) != 0x18)
        {
          printf("error 0x18, %i, val: %x\n", st, *((char *)input_items[j]+i));
          printf("nitems_items[%i]: %i, %i\n", j, nitems_items[j], i);
        }
    }

    consume_each(noutput_items);
  }
  return(noutput_items);
}


