#!/usr/bin/env python

from gnuradio import eng_notation
from gnuradio import gr, gru, blks2
from gnuradio.eng_option import eng_option
from gnuradio.gr import firdes
from optparse import OptionParser
import sys

for extdir in ['../lib','../lib/.libs']:
      if extdir not in sys.path:
                sys.path.append(extdir)
import ccr

class test(gr.top_block):
  def __init__(self):
    gr.top_block.__init__(self)

		##################################################
		# Connections
		##################################################
    self.block = self._set_block()

    self.src0 = self._set_source("out/file0.cf")
    self.src1 = self._set_source("out/file1.cf")
    self.src2 = self._set_source("out/file2.cf")
    self.src3 = self._set_source("out/file3.cf")
    self.src4 = self._set_source("out/file4.cf")
    self.src5 = self._set_source("out/file5.cf")

    self.sink = self._set_sink()

    self.connect(self.src0, (self.block, 0))
    self.connect(self.src1, (self.block, 1))
    self.connect(self.src2, (self.block, 2))
    self.connect(self.src3, (self.block, 3))
    self.connect(self.src4, (self.block, 4))
    self.connect(self.src5, (self.block, 5))

    self.connect((self.block, 0), self.sink)

  def _set_block(self):
    blk = ccr.receiver_cf()
    return blk

  def _set_sink(self):
    filesink = gr.null_sink(gr.sizeof_float)
    return filesink

  def _set_source(self, ifile):
    filesrc = gr.file_source(gr.sizeof_gr_complex, ifile, False)
    return filesrc

def main():
  try:
    test().run()
  except KeyboardInterrupt:
    pass

if __name__ == '__main__':
  main()

